/*
 * @Copyright 2010, MechSoft 
 * MechSoft, Mechanical and Software Solutions 
 * 
 * Licensed under the Apache License, Version 2.0 (the 
 * "License"); you may not use this file except in compliance 
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.samples.jsonexample;

import java.util.HashMap;
import java.util.Map;

import org.defne.server.json.JsonServiceMessage;
import org.defne.service.IMessageConstants;
import org.defne.service.Message;
import org.defne.service.MessageFactory;
import org.defne.service.TransactionPolicy;

public class HelloAdaptor extends JsonServiceMessage
{
    private static final long serialVersionUID = 1L;

    private Map<String, String> args;

    @Override
    public Map<String, String> fromOutputMessage(Message message)
    {
        Map<String, String> out = new HashMap<String, String>();
        out.put("MESSAGE", message.getMessageParameter(String.class, "MESSAGE"));
        
        return out;
    }

    @Override
    public Message toInputMessage()
    {
        Message message = MessageFactory.newMessage(service, method);
        
        //GEt name
        message.putMessageParameter(IHelloService.SayHelloOperation.INPUT.NAME, args.get(IHelloService.SayHelloOperation.INPUT.NAME));
        
        //Get salary
        Integer integer = new Integer(args.get(IHelloService.SayHelloOperation.INPUT.SALARY));
        
        //Put args
        message.putMessageParameter(IHelloService.SayHelloOperation.INPUT.SALARY, integer);
        
        //No transaction 
        message.setTransactionPolicy(TransactionPolicy.NO_TRANSACTION);
        
        //No JPA, default use JPA
        message.putMessageParameter(IMessageConstants.SERVICE_CALLER_USES_ENTITY_MANAGER_KEY, false);
        
        return message;
    }
}
