/*
 * @Copyright 2010, MechSoft 
 * MechSoft, Mechanical and Software Solutions 
 * 
 * Licensed under the Apache License, Version 2.0 (the 
 * "License"); you may not use this file except in compliance 
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.samples.jsonexample;

import java.util.HashMap;
import java.util.Map;

import org.defne.server.json.JsonServiceMessage;
import org.defne.service.Message;
import org.defne.service.MessageFactory;

public class PersonAdapter extends JsonServiceMessage
{

    private static final long serialVersionUID = 1L;

    private Person person;
    
    @Override
    public Object fromOutputMessage(Message message)
    {
        Map<String, String> map = new HashMap<String, String>();
        map.put("SUCCESS", "true");
        
        return map;
    }

    @Override
    public Message toInputMessage()
    {
        Message message = MessageFactory.newMessage(IHelloService.SERVICE_NAME,IHelloService.PrintPersonOperation.OPERATION_NAME);
        message.putMessageParameter(IHelloService.PrintPersonOperation.INPUT.PERSON, this.person);
        
        return message;
    }

    
}
